# vKVM Library

This library allows for easy interaction with the graphical user interface of the vKVM project.


## Features

- set pixel color
- respond to keyboard/mouse events
- get/set text to be drawn

## Installation

Use the installation script provided in the Scripts repository
to install the full package.

Installing a single component is currently not supported.

## Include

Include this library with

```
set(LIB_PATH "${CMAKE_SOURCE_DIR}/../relative_path_to_library_folder")

include_directories(${LIB_PATH}/include)
add_executable(your_client ${SOURCES} ${HEADERS})

target_link_libraries(your_client ${LIB_PATH}/lib/liblibrary.a)
```
in your CMakeList.

## Usage

```cpp
#include <vkvm.h>

int main(int argc, char* argv[]) {
    if(argc != 1) return -1;
    int pid = std::stoi(argv[0]);
    initialize(pid);

    setPixel(10, 10, Color::black);
    setPixel(10, 20, Color::red);
}

```